program demo;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  Windows,
  SysUtils,
  vm_core in 'vm_core.pas';

function GenerateSerial(const Login: AnsiString): AnsiString;
var
  I: Integer;
  LoginValue: Integer;
begin
  LoginValue := 0;
  Result := '';
  for I := 1 to Length(Login) do
  begin
    LoginValue := LoginValue shl 2;
    LoginValue := LoginValue + Byte(Login[I]);
    LoginValue := LoginValue xor $48ADEEEF;
    LoginValue := LoginValue * Byte(Login[I]);
  end;
  Result := AnsiString(IntToHex(LoginValue, 8));
end;

// =============================================================================

function CharToByte(Value: PByte): Byte;
var
  B: Byte;
begin
  Result := Value^;
  if Result > $39 then
    Dec(Result, $37)
  else
    Dec(Result, $30);
  Inc(Value);
  B := Value^;
  if B > $39 then
    Dec(B, $37)
  else
    Dec(B, $30);
  Result := (Result shl 4) + B;
end;

function SimpleHexToInt(const Value: AnsiString): Integer;
begin
  Result :=
    CharToByte(@Value[1]) shl 24 +
    CharToByte(@Value[3]) shl 16 +
    CharToByte(@Value[5]) shl 8  +
    CharToByte(@Value[7]);
end;

function CheckSerial(const Login, Serial: AnsiString): Boolean;
var
  I: Integer;
  LoginValue: Integer;
  SerialIntValue: Integer;
begin
  LoginValue := 0;
  for I := 1 to Length(Login) do
  begin
    LoginValue := LoginValue shl 2;
    LoginValue := LoginValue + Byte(Login[I]);
    LoginValue := LoginValue xor $48ADEEEF;
    LoginValue := LoginValue * Byte(Login[I]);
  end;
  SerialIntValue := SimpleHexToInt(Serial);
  Result := SerialIntValue = LoginValue;
end;

// =============================================================================

function vmCharToByte(Value: PByte): Byte;
var
  A, B: Byte;
  F: TFlags;
begin
  vmMovU8(Value^, A);
  F := vmCmp(A, $39, bs8);
  B := vmIfThen($37, $30, vmJmp_G(F));
  Result := vmSub(A, B, bs8);
  Result := vmShl(Result, 4, bs8);
  Value := PByte(vmInc(Integer(Value)));
  vmMovU8(Value^, A);
  F := vmCmp(A, $39, bs8);
  B := vmIfThen($37, $30, vmJmp_G(F));
  B := vmSub(A, B, bs8);
  Result :=  vmAdd(Result, B, bs8);
end;

function vmSimpleHexToInt(const Value: AnsiString): Integer;
begin
  Result :=
    vmShl(vmCharToByte(@Value[1]), 24, bs32) +
    vmShl(vmCharToByte(@Value[3]), 16, bs32) +
    vmShl(vmCharToByte(@Value[5]), 8, bs32)  +
    vmCharToByte(@Value[7]);
end;

function vmCheckSerialEx(const Login, Serial: AnsiString): Boolean;
var
  I: Integer;
  LoginValue: Integer;
  F: TFlags;
  SerialIntValue: Integer;
begin
  vmMov32(0, LoginValue);
  for I := 1 to Length(Login) do
  begin
    LoginValue := vmShl(LoginValue, 2, bs32);
    LoginValue := vmAdd(LoginValue, Integer(Login[I]), bs32);
    LoginValue := vmXor(LoginValue, $48ADEEEF);
    LoginValue := vmMul(LoginValue, Byte(Login[I]), bs32);
  end;
  SerialIntValue := vmSimpleHexToInt(Serial);
  F := vmCmp(LoginValue, SerialIntValue, bs32);
  Result := vmJmp_E(F);
end;

// =============================================================================

function vmCheckSerial(const Login, Serial: AnsiString): Boolean;
begin
  Result := False;
  if Length(Serial) <> 8 then
    Exit;
  if Length(Login) = 0 then
    Exit;
  Result := vmCheckSerialEx(Login, Serial);
end;

var
  Login: AnsiString;
  Serial: AnsiString;
begin
  Login := 'Rouse_';
  Serial := '81E537F8';
  Writeln(CheckSerial(Login, Serial));
  Writeln(vmCheckSerial(Login, Serial));
  Readln;
end.
